//*****************************************
// AVR ATmega164 Test Program for Five_by_Eight_644_UTL BOARD
// CPU Clock:1MHz
//   iq[Yf[^@WāAIV[^(8MHz)ɂBis`f̓`FbNj
//
// File Name:five_by_eight_164_utl.c
//
//
//@kdc
//@@obOFgœ_Akŏ
//
//@̑̐M͏o͂Ł@kdc͐ڑĂȂ
//
//
//	
//@@N@kdciobOj@ODTbƂ̓_łs
//@@@̓_ł̓_̃^C~O
//@@@o`OAo`PAo`QAo`RAo`SAo`TAo`UAo`VA
//@@@oaOAoaPAoaQAoaRAoaSAoaTAoaUAoaVA
//@@@obPAobQAobRAobSAobTAobUAobVA
//@@@ocOAocPAocQAocRAocSAocTAocUAocVA
//@@@̏ԂɁ@PbԂgo͂A
//
//
//  2013/06/06 Taishi
//*****************************************
#include	<avr/io.h>


// ********************* Port A *****************************
#define	NofPaData	8
unsigned char	pa_data[NofPaData] = {(1 << PA0), (1 << PA1), (1 << PA2), (1 << PA3), (1 << PA4), (1 << PA5), (1 << PA6), (1 << PA7) };		// PORT-A Output Data

// ********************* Port B *****************************
#define	NofPbData	8
unsigned char	pb_data[NofPbData] = {(1 << PB0), (1 << PB1), (1 << PB2), (1 << PB3), (1 << PB4), (1 << PB5), (1 << PB6), (1 << PB7) };		// PORT-B Output Data

// ********************* Port C *****************************
#define	NofPcData	7
unsigned char	pc_data[NofPcData] = {(1 << PC1), (1 << PC2), (1 << PC3), (1 << PC4), (1 << PC5), (1 << PC6), (1 << PC7) };					// PORT-C Output Data

// ********************* Port D *****************************
#define	NofPdData	8
unsigned char	pd_data[NofPdData] = {(1 << PD0), (1 << PD1), (1 << PD2), (1 << PD3), (1 << PD4), (1 << PD5), (1 << PD6), (1 << PD7) };		// PORT-D Output Data

// **********************************************************
// ********************** Soft Timer ************************
// **********************************************************
volatile unsigned short	wait_i;
volatile unsigned short	wait_j;
volatile unsigned char	wait_us;
// ************************************
// Delay 16uS
// t: 16uS (max 255)
// ************************************
void delay_16us(unsigned char t)
{
	while(t-- != 0){
		wait_us++;				// 1uS Delay??
	}
}
//***************************
// Wait
//  tm : Wait Time(ms) max. 8000
// CPU Clock:1MHz
//***************************
void	delay_ms(short tm)
{

	tm *= 2;
	for(wait_i = 0; wait_i < tm; wait_i++){
		delay_16us(63);
	}
}

//******************************
// LED ON/OFF
//  on_off : 1=ON, 0=OFF
// *****************************
void	led_on_off(unsigned char on_off)
{
	if(on_off == 0){
		PORTC &= ~(1 << PC0);		// LED OFF
	}else{
		PORTC |=  (1 << PC0);		// LED ON
	}
}
//*****************************************
// Main
//*****************************************
int	main(void)
{
	unsigned char	i;

	PRR |= ( (1 << PRTWI) | (1 << PRSPI) | (1 << PRUSART0) | (1 << PRTIM0) | (1 << PRTIM1) | (1 << PRTIM2) | (1 << PRADC) );	// TWI, SPI, UART0, Timer0, Timer1, Timer2, ADC ~


	DDRA = ((1 << DDA0) | (1 << DDA1) | (1 << DDA2) | (1 << DDA3) | (1 << DDA4) | (1 << DDA5) | (1 << DDA6) | (1 << DDA7));		// PA0--7:Output
	DDRB = ((1 << DDB0) | (1 << DDB1) | (1 << DDB2) | (1 << DDB3) | (1 << DDB4) | (1 << DDB5) | (1 << DDB6) | (1 << DDB7));		// PB0--7:Output
	DDRC = ((1 << DDC0) | (1 << DDC1) | (1 << DDC2) | (1 << DDC3) | (1 << DDC4) | (1 << DDC5) | (1 << DDC6) | (1 << DDC7));		// PC0--7:Output
	DDRD = ((1 << DDD0) | (1 << DDD1) | (1 << DDD2) | (1 << DDD3) | (1 << DDD4) | (1 << DDD5) | (1 << DDD6) | (1 << DDD7) );	// PD0--7:Output

	delay_ms(200);												// 200mS Delay


	for(;;){
		for(i=0;i<NofPaData;i++){
			PORTA = pa_data[i];						// PORT-A Output
			led_on_off(1);							// LED ON
			delay_ms(500);							// 500mS Delay
			led_on_off(0);							// LED OFF
			delay_ms(500);							// 500mS Delay
		}
		PORTA = 0;									// PORT-A Output ALL Low

		for(i=0;i<NofPbData;i++){
			PORTB = pb_data[i];						// PORT-B Output
			led_on_off(1);							// LED ON
			delay_ms(500);							// 500mS Delay
			led_on_off(0);							// LED OFF
			delay_ms(500);							// 500mS Delay
		}
		PORTB = 0;									// PORT-B Output ALL Low

		for(i=0;i<NofPcData;i++){
			PORTC = pc_data[i];						// PORT-C Output
			led_on_off(1);							// LED ON
			delay_ms(500);							// 500mS Delay
			led_on_off(0);							// LED OFF
			delay_ms(500);							// 500mS Delay
		}
		PORTC = 0;									// PORT-C Output ALL Low

		for(i=0;i<NofPdData;i++){
			PORTD = pd_data[i];						// PORT-D Output
			led_on_off(1);							// LED ON
			delay_ms(500);							// 500mS Delay
			led_on_off(0);							// LED OFF
			delay_ms(500);							// 500mS Delay
		}
		PORTD = 0;									// PORT-D Output ALL Low

	}
}
